// Progetto 8 Capitolo 5 libro Savitch.

package esercizio2;
import java.util.*;

public class ParolaSegreta {
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		
		System.out.print("Inserire la parola segreta: ");
		String parolaSegreta = tastiera.next();
		
		int numeroTentativi = 0;
		String lettereScoperte = preparaParola(parolaSegreta);
		do{
			System.out.println("Indovina la parola: "+lettereScoperte);
			System.out.println("Tentativo n "+(numeroTentativi+1));
			System.out.print("Inserisci il carattere: ");
			String carattere = tastiera.next();
			lettereScoperte = provaCarattere(parolaSegreta,lettereScoperte,carattere.charAt(0));
			numeroTentativi++;
		}while(!tutteScoperte(lettereScoperte));
		System.out.println("Indovinata! La parola era: "+parolaSegreta);
		System.out.println("Hai indovinato in "+numeroTentativi+" tentativi");
		tastiera.close();
	}

	public static String preparaParola(String parola){
		String parolaNascosta = "";
		for(int i=0; i<parola.length();i++)
			parolaNascosta += "?";
		return parolaNascosta;
		
	}
	
	public static String provaCarattere(String parolaSegreta, String parolaNascosta, char c){
		for(int i=0; i<parolaSegreta.length(); i++)
			if(parolaSegreta.charAt(i)==c)
				parolaNascosta = parolaNascosta.substring(0,i)+c+parolaNascosta.substring(i+1);
		return parolaNascosta;
	}
	
	public static boolean tutteScoperte(String parolaNascosta){
		boolean indovinata = true;
		for(int i=0; i<parolaNascosta.length() && indovinata; i++)
			if(parolaNascosta.charAt(i)=='?')
				indovinata=false;
		return indovinata;
	}
}
